$(function () {
  var LS = window.LS || {};

  $(".uniquesButtton[data-url]").click(function (e) {
    e.preventDefault();

    var uniqueButton = $(this);

    return $.get(uniqueButton.data("url"), function (resp) {
      var respBody = $(resp),
          title = respBody.find("h1").html(),
          body = respBody.find(".content").html();

      uniqueButton.popover({
        html: true,
        trigger: 'manual',
        placement: 'bottom',
        title: title,
        content: body
      });
      uniqueButton.popover('show');
    });
  });
  // Click on 'X' - Closes without saving
  $(".popover-title .close").live('click', function () {
    $(".popover:visible").remove();
  });

  $(".popover:visible").live('click', function (e) {
    e.stopPropagation();
  });

  // Click outside of pop-up - Save and Close
  $(document).click(function () {
    if ($(".popover").is(":visible")) {
      if ($('#IPAddressFilteringForm').length) {
        submitAdvancedOptionsPopup($("#IPAddressFilteringForm"));
      } else {
        $(".popover:visible").remove();
      }
      return false;
    }
  });


  //Restrict to number of users checkbox
  $("input.restrict-subnet").live('click', function () {
    var input = $(this).parents(".control-group:eq(0)").find("input:visible:not(:checkbox)");
    var restrict = $(this).is(":not(:checked)");
    input.attr("disabled", restrict);
  });

  //Restrict to number of users checkbox
  $("input.enable-token, input.restrict-token").live('change', function () {
    var tokenid = $(this).data().tokenid;
    var enableTokenCb = $(".enable-token[data-tokenid=" + tokenid + "]");
    var restrictTokenCb = $(".restrict-token[data-tokenid=" + tokenid + "]");
    restrictTokenCb.attr("disabled", enableTokenCb.is(":not(:checked)"));

    var input = $(".input-mini[data-tokenid=" + tokenid + "]");
    input.attr("disabled", enableTokenCb.is(":not(:checked)") || restrictTokenCb.is(":not(:checked)"));
  });

  //ESC - Closes without saving
  $(document).keyup(function(e) {
    if (e.keyCode === 27) {
      $(".popover:visible").remove();
    }
  });

  //ENTER (on input field) - Save and Close
  $(".popover input[name=maxUsers], .popover input[name=subnetMask]").live('keydown', function (e) {
    if (e.keyCode === 13) {
      submitAdvancedOptionsPopup($("#IPAddressFilteringForm"));
      return false;
    }
  });

  var submitAdvancedOptionsPopup = function (input) {
    var form = $(input);
    var id = form.find("[name='id']").val();

    LS.common.ajaxFormSubmit(form, function () {
      $(".uniquesButtton").popover('destroy');
      //Update page with new values

      //update subnet mask
      var subnetMask = form.find(".restrict-subnet").is(':checked') ? form.find("[name=subnetMask]").val().trim() : "";
      $("#subnetMask_" + id).html(!subnetMask ? "Any IP" : subnetMask);

      var productEl = $(".product[data-groupid='" + id + "']").html("");
      //update products list in table column
      form.find(".enable-token:checked")
        .map(function (idx, el) {
          return {name: el.dataset.longproductname, short: el.dataset.shortproductname};
        })
        .each(function (idx, el) {
          return $("<span />").addClass("no-wrap").attr("title", el.name)
            .text(el.short).append("<br />")
            .appendTo(productEl);
        });

    }, function (resp) {
      popoverPreloader(form, false);
      var errors = _.pairs($.parseJSON(resp.responseText));
      form.find(".alert-error").addClass("hide").html("");
        for (var index = 0; index < errors.length; ++index) {
            var div = form.find("div[name='" + errors[index][0] + "-error']");
            div.html(errors[index][1]);
            div.removeClass("hide");
        }
    },function () {
      popoverPreloader(form, true);
    }).submit();
  };

  function popoverPreloader(object, toggle) {
    var closeButton = object.parents(".popover").find(".close");
    var preloader = closeButton.siblings(".preloader");
    if (toggle) {
      closeButton.hide();
      if (preloader.length == 0) {
        preloader = LS.common.preloaderImage().addClass("pull-right preloader");
        closeButton.after(preloader);
      }
      else {
        preloader.show();
      }
    }
    else {
      closeButton.show();
      preloader.hide();
    }
  }

  $("#tokenChooser").change(function () {
    $("[id^=tokenUrl_]").hide();
    $("#tokenUrl_" + $(this).val()).css("display", 'inline');
  }).change();

  $(".sendToken").click(function () {
    var button = $(this);
    var content = $("#sendTokenContent").html().replace("[[token]]", button.data("token-url")).replace("[[token2]]", button.data("token-url")).replace("[[adminEmail]]", button.data("admin-email"));
    button.popover('destroy').popover({
      html: true,
      trigger: 'manual',
      placement: 'bottom',
      title: "Email Token<button class='close'>×</button>",
      content: content
    });
    button.popover('show');
    var popover = $(".popover:visible");

    $("input[placeholder],textarea[placeholder]").each(function () {
      $(this).watermark($(this).attr("placeholder"));
    });

    var form = popover.find("form");
    LS.common.ajaxFormSubmit(form, function () {
      popover.remove();
    }, function (resp) {
      popover.find(".alert-error").removeClass("hide").html(resp.responseText);
      popoverPreloader(form, false);
    }, function () {
      popoverPreloader(form, true);
    });
    return false;
  }).filter(".openRightAway").click();

  $("button.deactivation").click(function () {
    var modalEl = $(this).next();
    modalEl.on('hide', function(){
      modalEl.removeClass('modal');
    })
    .modal('show')
    .addClass('modal');
  });

  $("#licenseType").change(function() {
    var isFloating = (this.value === "0");
    var type = isFloating ? "LS_FLOATING" : "LS_MANAGED";

    $(".lictypes").attr("disabled", true);
    $(".lictypes." + type).attr("disabled", false);
    $(".lictypes.enable-token").toggle(!isFloating).attr("checked", true);

    // hide non JRebel products for floating group
    $(".productEntry").each(function(){
      var el = $(this);
      if (el.hasClass("JRebel")) {
        return;
      }
      if (el.hasClass("dummyCheckbox")) {
        el.toggle(isFloating);
      }
      else {
          el.toggle(!isFloating);
      }
    });

    $("form.add-group input.enable-token, form.add-group input.restrict-token").trigger("change");
  });
});
